
# Contribution guide  

Welcome! We are very happy that you are here and look forward to your interest in participating in FortuneSheet contributions. Of course, before you participate in the FortuneSheet contribution, please make sure to read the following full text:

## Our code of conduct

1. We promise to respect all those who participated in the contribution, not limited to those who raised questions, contributed documents and code, resolved bugs and other contributions;
2. We are obliged to abide by local laws and regulations, and we reject all behaviors with legal risks;
3. We oppose any participant's derogatory comments, personal attacks, harassment or insult to others, and other non-professional behaviors;
4. We have the right and responsibility to delete or edit content that does not comply with this code of conduct, not limited to code, issues, wikis, documents and others. Participants who do not comply with the code of conduct may be removed from the team;
5. We accept the supervision of anyone, and anyone can report to us the facts that are found to be inconsistent with this code of conduct through problem feedback.

<!-- ## How to participate in contributing?

* Contributed documents: Browsing the document can deepen your understanding of FortuneSheet. Once you find that the document is not clearly written or the logic is confusing, you can correct, modify, and supplement. You can go to [Google Forum](https://groups.google.com/g/FortuneSheet) to give feedback
* Contributing code: Welcome everyone to contribute code to the FortuneSheet community, you are welcome to claim the Open state [Issues](https://github.com/ruilisi/fortune-sheet/issues) and unfinished features, submit a PR, and become one of the contributors If you find that some functions cannot meet your needs or have problems during use, please record in Issues
* Participate in the issue discussion: you can post your suggestions under any [Issues](https://github.com/ruilisi/fortune-sheet/issues)
* Review code: You can see PR submitted by all contributors on [Github](https://github.com/mengshukeji/FortuneSheet), you can review their code and post your suggestions -->

## How to submit issues

Before you submit features/improvements, you should pay attention to the following points:

* Please confirm whether the feature/improvement has been submitted by others
* An easy-to-understand title to explain the bug/submission feature/improvement you submitted
* If it is a bug, describe the cause of the bug in detail. If it can be reproduced, please try to provide complete reproduction steps
* If it is a feature, then the feature should have wide applicability, suitable for most users, and it is best to provide detailed design documents
* If it is an improvement, describe the benefits of this improvement as clearly as possible

Specific steps:

* Create [Issues](https://github.com/ruilisi/fortune-sheet/issues) and describe the issue clearly
* If you want to solve the issue, assign the issue to your own name. If you just submit a bug/feature/improvement and don’t have time to contribute code, set assignne to empty
<!-- * If it is a relatively large feature/improvement, try to output the design document first and follow the [FortuneSheet RFC](https://github.com/mengshukeji/FortuneSheet-rfcs) process for others to review -->

## How to claim Issues

In FortuneSheet's [Issues](https://github.com/ruilisi/fortune-sheet/issues) list, there are many issues created by others that have not been repaired. If you are interested, you can claim these issues. The steps to claim are as follows:

* Leave a message under the issue, express the idea of claiming the task, and specify **@I can solve it**
* If the submitter has no comments, assign the issue to your own name and update the progress in time
<!-- * If it is a relatively large feature, try to output the design document first and follow the [FortuneSheet RFC](https://github.com/mengshukeji/FortuneSheet-rfcs) process for others to review -->
* Develop the code and submit the code to github

## Code Specification

This project has configured `eslint` and `prettier`, if they claim error when you commit code, be sure to fix them before committing again.

## How to contribute documents

## How to become FortuneSheet Committer

As long as anyone contributes to the FortuneSheet project, you are the officially recognized Contributor of the FortuneSheet project. There is no exact standard for growing from Contributor to Committer, and there is no expected timetable, but Committer candidates are generally A long-term active contributor, becoming Committer does not require a huge architectural improvement contribution, or how many lines of code contributions, contributing code, contributing documents, participating in mailing list discussions, helping to answer questions, etc., are all ways to increase their influence .

List of potential contributions (in no particular order):

* Submit the bugs, features, and improvements you found to the issue
* Update the official documents so that the project documents are the most recent, the best practices for writing FortuneSheet, and various useful documents for the users
* Perform test and report test results, performance test and other MQ performance comparison test, etc.
* Review the work of others (including code and non-code) and publish your own suggestions
* Guide new contributors and be familiar with the community process
* Post a blog about FortuneSheet
* Any contribution to the development of the FortuneSheet community
* ......
